#載入 tcoreapi
from tcoreapi_mq import * 
#載入我們提供的行情 function
from quote_functions import *
import json
import pandas as pd

g_QuoteZMQ = None
g_QuoteSession = ""
	
def main():

    global g_QuoteZMQ
    global g_QuoteSession
    global testSymbol

    #建立 ZMQ 聯綫

    #設定連綫授權碼，通常不用改。
    g_QuoteZMQ = QuoteAPI("ZMQ","8076c9867a372d2a9a814ae710c256e2")
    
    #設定連接 Port，通常不用改。
    q_data = g_QuoteZMQ.Connect("51647")

    #連綫成功后，將取得的 Session Key 儲存下來，後面調用指令需要帶入。
    g_QuoteSession = q_data["SessionKey"]

    #登出
    #q_logout= g_QuoteZMQ.Logout(q_data["SessionKey"])
    #print(q_logout)

    #設定合約代碼，測試時請注意範例的合約是否已經下市。
    testSymbol = "TC.F.TWF.MXF.202201"

    #查詢指定合約資訊
    print( "" )
    print( "查詢指定合約：", testSymbol )

    res = g_QuoteZMQ.QueryInstrumentInfo(g_QuoteSession, testSymbol )
    print( type( res ) )
    print( res )


    #查詢指定類型合約列表
    #期貨：Fut
    #期權：Opt
    #證券：Stock

    #查詢全部期貨合約
    print( "" )
    print( "查詢全部期貨合約：" )
    res = g_QuoteZMQ.QueryAllInstrumentInfo(g_QuoteSession,"Fut")
    print( type( res ) )
    print( res )




if __name__ == '__main__':
    main()