#載入 tcoreapi
from tcoreapi_mq import * 
#載入我們提供的行情 function
from quote_functions import *
import threading

g_QuoteZMQ = None
g_QuoteSession = ""
	
def main():

    global g_QuoteZMQ
    global g_QuoteSession
    global testSymbol

    #建立 ZMQ 聯綫

    #設定連綫授權碼，通常不用改。
    g_QuoteZMQ = QuoteAPI("ZMQ","8076c9867a372d2a9a814ae710c256e2")
    
    #設定連接 Port，通常不用改。
    q_data = g_QuoteZMQ.Connect("51647")

    print(q_data)

    if q_data["Success"] != "OK":
        print("[ quote ]connection failed")
        return

    #連綫成功后，將取得的 Session Key 儲存下來，後面調用指令需要帶入。
    g_QuoteSession = q_data["SessionKey"]

#####################################################################行情################################################
    #建立一個行情線程
    t1 = threading.Thread(target = quote_sub_th,args=(g_QuoteZMQ,q_data["SubPort"],))
    t1.start()
    
    #實時行情訂閱
    #設定合約代碼，測試時請注意範例的合約是否已經下市。
    #testSymbol = "TC.F.TWF.TXF.202201"
    testSymbol = "TC.O.TWF.TXO.202201.C.18400"

    #訂閱歷史數據
    # message["DataType"]="TICKS"   ticks
    # message["DataType"]="1K"   1K
    # message["DataType"]="DK"   日K
    # message["DataType"]="DOGSS"   Greeks 秒數據
    # message["DataType"]="DOGSK"   Greeks 分鐘數據
    # 回補區間設定
    # yyyymmddHH, HH 00-23
    ktype = '1K'
    sD = '2022010300'
    eD = '2022010323'

    GetHistory(g_QuoteZMQ, g_QuoteSession, testSymbol, ktype, sD, eD)

if __name__ == '__main__':
    main()